<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { BoxLayout, DisplayMode } from '@shopware-pwa/composables-next';

  const props = withDefaults(
    defineProps<{
      data: Product;
      loading?: boolean;
      displayMode?: DisplayMode;
      boxLayout?: BoxLayout;
    }>(),
    {
      loading: false,
      displayMode: 'cover',
      boxLayout: 'standard',
    },
  );
  const product = computed(() => props.data);
  const productId = computed(() => props.data.id);
  const { quickViewModalController } = useQuickView();
  const { isGuide, isClient } = useUser();
  const { requestDynamicPage } = useDynamicPage();
  const { addToCart, loading: loadingAddToCart, countAll } = useAddToCart(product);
  const { isLiked, like, toggleLike, unlike, loading: loadingLike } = useLikeItem(productId);
  const { isSelfService } = useAppointment();
  const { isBookmarked, toggleBookmark, loading: loadingBookmark } = useBookmarkItem(productId);
  const { controlledClient, permissionGranted } = useParticipants();
  const { stateForGuides } = usePresentationState();

  const quickViewWatchers = computed(() => {
    if (!isGuide.value || isSelfService.value) return 0;
    const quickViewProduct = stateForGuides.value?.quickViewState?.[productId.value];
    if (quickViewProduct) {
      const quickViewAttendeeIds = Object.keys(quickViewProduct);

      quickViewAttendeeIds.forEach((id: string) => {
        if (stateForGuides.value?.guides[id]) delete quickViewProduct[id];
      });

      return Object.keys(quickViewProduct).length;
    } else {
      return 0;
    }
  });

  const isMainProduct = computed(() => {
    return !!(
      product.value.parentId === null &&
      product.value.childCount &&
      product.value.childCount > 0
    );
  });

  const isHaveAdvancedPrice = computed(() => {
    return !!(product.value.calculatedPrices.length > 1);
  });

  const handleLike = async () => {
    if (!product.value.extensions.attendeeProductCollections) {
      product.value.extensions.attendeeProductCollections = {};
    }

    if (!product.value.extensions.attendeeProductCollections?.likes) {
      product.value.extensions.attendeeProductCollections.likes = 0;
    }

    const currentLikes = Number(product.value.extensions.attendeeProductCollections.likes);
    if (isLiked.value) {
      await unlike();
      if (currentLikes >= 1) {
        product.value.extensions.attendeeProductCollections.likes = currentLikes - 1;
      }
    } else {
      await like();
      product.value.extensions.attendeeProductCollections.likes = currentLikes + 1;
    }
  };

  const handleClick = () => {
    if (isSelfService.value) {
      requestDynamicPage({
        type: DynamicPageType.PRODUCT,
        productId: product.value.id,
      });
    } else {
      quickViewModalController.open(product.value.id);
    }
  };

  const handleOpenDetails = (e: Event) => {
    e.stopPropagation();

    if (isGuide.value || isSelfService.value) {
      requestDynamicPage({
        type: DynamicPageType.PRODUCT,
        productId: product.value.id,
      });
    } else {
      quickViewModalController.open(product.value.id);
    }
  };
</script>
<template>
  <SwProductCard
    :loading="loading"
    :data="product"
    :display-mode="displayMode"
    :box-layout="boxLayout"
    :watchers="quickViewWatchers"
    :is-main-product="isMainProduct"
    @click="handleClick"
  >
    <template #product-interact>
      <div v-if="isGuide" class="flex gap-1.5">
        <SwBookmarkButton
          variant="action"
          class="!px-2"
          :is-bookmarked="isBookmarked"
          :loading="loadingBookmark"
          @click="toggleBookmark"
        />
        <SwTooltip
          :disabled="isMainProduct || !controlledClient || permissionGranted"
          :content="$t('permissionToolTip')"
          position="topCenter"
          width="max-width"
        >
          <SwButton
            variant="action"
            class="border-transparent bg-gray-50 !px-2 shadow-none"
            :disabled="isMainProduct || !controlledClient || !permissionGranted"
            :loading="loadingAddToCart"
            @click="addToCart()"
          >
            <template #icon>
              <span class="i-sw-solid:shopping-cart text-sm" />
            </template>
            <template #default>
              {{ countAll }}
            </template>
          </SwButton>
        </SwTooltip>
        <SwButton
          variant="action"
          class="border-transparent bg-gray-50 !px-2 shadow-none"
          :disabled="!controlledClient"
          :loading="loadingLike"
          @click="handleLike"
        >
          <template #icon>
            <span :class="['i-sw-solid:heart text-sm', { 'text-crimson-500': isLiked }]" />
          </template>
          <template #default>
            {{ (product?.extensions as any)?.attendeeProductCollections?.likes }}
          </template>
        </SwButton>
      </div>
      <SwLikeButton
        v-else-if="isClient"
        class="!px-2"
        variant="action"
        :is-liked="isLiked"
        :loading="loadingLike"
        @click="toggleLike"
      />
    </template>

    <template #product-action>
      <SwButton v-if="isGuide" variant="action" @click="handleOpenDetails">
        {{ $t('product.details') }}
      </SwButton>
      <div v-else-if="isClient">
        <SwButton
          v-if="isMainProduct || isHaveAdvancedPrice"
          class="w-full"
          variant="action"
          @click="handleOpenDetails"
        >
          {{ $t('product.details') }}
        </SwButton>
        <SwButton v-else class="w-full" :loading="loadingAddToCart" @click="addToCart()">
          <span class="i-sw-solid:shopping-cart mr-1 text-sm" />
          {{ $t('product.addToCart') }}
        </SwButton>
      </div>
    </template>
  </SwProductCard>
</template>
